=== modified file 'NEWS'
--- NEWS	2010-05-06 07:48:22 +0000
+++ NEWS	2010-04-28 09:40:23 +0000
@@ -16,10 +16,6 @@
 New Features
 ************
 
-* ``bzr commit`` accepts ``-p`` (for "patch") as a shorter name for
-  ``--show-diff``.
-  (Parth Malwankar, #571467)
-  
 * ``bzr ignore`` now supports a ``--default-rules`` option that displays
   the default ignore rules used by bzr. The flag ``--old-default-rules``
   is no longer supported by ``ignore``.
@@ -49,20 +45,9 @@
 * ``bzr selftest`` should not use ui.note() since it's not unicode safe.
   (Vincent Ladeuil, #563997)
 
-* Don't mention --no-strict when we just issue the warning about unclean trees.
-  (Vincent Ladeuil, #401599)
-
-* Fixed ``AssertionError`` when accessing smart servers running Bazaar
-  versions before 1.6.
-  (Andrew Bennetts, #528041)
-
 * Reduce peak memory by one copy of compressed text.
   (John Arbash Meinel, #566940)
 
-* Show the filenames when a file rename fails so that the error will be
-  more comprehensible.
-  (Martin Pool, #491763)
-
 Improvements
 ************
 
@@ -84,10 +69,6 @@
 API Changes
 ***********
 
-* Added ``bzrlib.merge.PerFileMerger``, a more convenient way to write
-  some kinds of ``merge_file_content`` hook functions.
-  (Andrew Bennetts)
-  
 * `BzrDir`, `Branch`, `Repository` and `WorkingTree` now all support `user_url`,
   `user_transport`, `control_url` and `control_transport` members pointing
   respectively to the directory containing the ``.bzr`` control directory, 
@@ -99,13 +80,6 @@
 Internals
 *********
 
-* ``_remember_remote_is_before`` no longer raises AssertionError when
-  suboptimal network behaviour is noticed; instead it just mutters to the
-  log file (and warns the user if they have set the ``hpss`` debug flag).
-  This was causing unnecessary aborts for performance bugs that are minor
-  at worst.
-  (Andrew Bennetts, #528041)
-
 * Permit bzr to run under ``python -OO`` which reduces the size of bytecode
   files loaded from disk. To ensure docstrings needed for help are never
   stripped, the prefix ``__doc__ =`` should now be used.
@@ -114,10 +88,6 @@
 Testing
 *******
 
-* Added ``bzrlib.tests.matchers`` as a place to put matchers, along with
-  our first in-tree matcher. See the module docstring for details.
-  (Robert Collins)
-
 * ``bzr selftest --parallel=subprocess`` now works correctly on win32.
    (Gordon Tyler, #551332)
 
@@ -192,9 +162,6 @@
   -rX..Y.
   (Vincent Ladeuil, #474807)
 
-* Properly handle ``param_name`` attribute for ``ListOption``.
-  (Martin von Gagern, 387117)
-
 Improvements
 ************
 
@@ -527,38 +494,6 @@
   happens, and another warning will be written if the log file could not
   be closed after retrying 100 times.  (Andrew Bennetts, #531746)
 
-bzr 2.1.2
-#########
-
-:2.1.2: NOT RELEASED YET
-
-Bug Fixes
-*********
-
-* ``bzr switch`` does not die if a ConfigurableFileMerger is used.
-  (Aaron Bentley, #559436)
-
-* Fixed ``AssertionError`` when accessing smart servers running Bazaar
-  versions before 1.6.
-  (Andrew Bennetts, #528041)
-
-* Reset ``siginterrupt`` flag to False every time we handle a signal
-  installed with ``set_signal_handler(..., restart_syscall=True)`` (from
-  ``bzrlib.osutils``.  Reduces the likelihood of "Interrupted System Call"
-  errors after two window resizes.
-  (Andrew Bennetts)
-
-Internals
-*********
-
-* ``_remember_remote_is_before`` no longer raises AssertionError when
-  suboptimal network behaviour is noticed; instead it just mutters to the
-  log file (and warns the user if they have set the ``hpss`` debug flag).
-  This was causing unnecessary aborts for performance bugs that are minor
-  at worst.
-  (Andrew Bennetts, #528041)
-
-
 bzr 2.1.1
 #########
 
@@ -592,12 +527,6 @@
   problems importing bzrlib from a non-main thread.
   (Elliot Murphy, #521989)
 
-* Repositories accessed via a smart server now reject being stacked on a
-  repository in an incompatible format, as is the case when accessing them
-  via other methods.  This was causing fetches from those repositories via
-  a smart server (e.g. using ``bzr branch``) to receive invalid data.
-  (Andrew Bennetts, #562380)
-
 * Standardize the error handling when creating a new ``StaticTuple``
   (problems will raise TypeError). (Matt Nordhoff, #457979)
 

=== modified file 'bzrlib/_readdir_py.py'
--- bzrlib/_readdir_py.py	2010-04-30 11:03:59 +0000
+++ bzrlib/_readdir_py.py	2009-03-23 14:59:43 +0000
@@ -17,6 +17,7 @@
 """Python implementation of readdir interface."""
 
 
+import os
 import stat
 
 

=== modified file 'bzrlib/add.py'
--- bzrlib/add.py	2010-04-30 11:03:59 +0000
+++ bzrlib/add.py	2009-04-04 02:50:01 +0000
@@ -16,11 +16,15 @@
 
 """Helper functions for adding files to working trees."""
 
+import errno
+import os
 import sys
 
 import bzrlib.bzrdir
+import bzrlib.errors as errors
 import bzrlib.osutils
 from bzrlib.symbol_versioning import *
+from bzrlib.workingtree import WorkingTree
 
 
 class AddAction(object):

=== modified file 'bzrlib/atomicfile.py'
--- bzrlib/atomicfile.py	2010-04-30 11:03:59 +0000
+++ bzrlib/atomicfile.py	2010-03-10 13:25:36 +0000
@@ -16,6 +16,7 @@
 
 
 import os
+import sys
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """

=== modified file 'bzrlib/bugtracker.py'
--- bzrlib/bugtracker.py	2010-04-30 11:03:59 +0000
+++ bzrlib/bugtracker.py	2010-02-17 17:11:16 +0000
@@ -14,7 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
-from bzrlib import registry
+from bzrlib import registry, help_topics
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import errors, urlutils

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-05-03 09:07:50 +0000
+++ bzrlib/builtins.py	2010-04-28 09:40:23 +0000
@@ -1132,10 +1132,8 @@
         else:
             revision_id = None
         if tree is not None and revision_id is None:
-            tree.check_changed_or_out_of_date(
-                strict, 'push_strict',
-                more_error='Use --no-strict to force the push.',
-                more_warning='Uncommitted changes will not be pushed.')
+            tree.warn_if_changed_or_out_of_date(
+                strict, 'push_strict', 'Use --no-strict to force the push.')
         # Get the stacked_on branch, if any
         if stacked_on is not None:
             stacked_on = urlutils.normalize_url(stacked_on)
@@ -3073,7 +3071,7 @@
                          "the master branch until a normal commit "
                          "is performed."
                     ),
-             Option('show-diff', short_name='p',
+             Option('show-diff',
                     help='When no message is supplied, show the diff along'
                     ' with the status summary in the message editor.'),
              ]
@@ -4681,7 +4679,6 @@
 
 class cmd_bind(Command):
     __doc__ = """Convert the current branch into a checkout of the supplied branch.
-    If no branch is supplied, rebind to the last bound location.
 
     Once converted into a checkout, commits must succeed on the master branch
     before they will be applied to the local branch.

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2010-04-30 11:35:43 +0000
+++ bzrlib/check.py	2010-04-23 00:44:15 +0000
@@ -46,9 +46,13 @@
   indicating that the revision was found/not found.
 """
 
-from bzrlib import errors
+from bzrlib import errors, osutils
+from bzrlib import repository as _mod_repository
+from bzrlib import revision
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
+from bzrlib.errors import BzrCheckError
+from bzrlib.repository import Repository
 from bzrlib.revision import NULL_REVISION
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.trace import note

=== modified file 'bzrlib/clean_tree.py'
--- bzrlib/clean_tree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/clean_tree.py	2009-03-23 14:59:43 +0000
@@ -15,10 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
+import errno
 import os
 import shutil
+import sys
 
-from bzrlib.osutils import isdir
+from bzrlib.osutils import has_symlinks, isdir
 from bzrlib.trace import note
 from bzrlib.workingtree import WorkingTree
 

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2010-04-30 11:35:43 +0000
+++ bzrlib/commit.py	2010-04-10 09:22:04 +0000
@@ -49,12 +49,20 @@
 # TODO: Change the parameter 'rev_id' to 'revision_id' to be consistent with
 # the rest of the code; add a deprecation of the old name.
 
+import os
+import re
+import sys
+import time
+
+from cStringIO import StringIO
+
 from bzrlib import (
     debug,
     errors,
     revision,
     trace,
     tree,
+    xml_serializer,
     )
 from bzrlib.branch import Branch
 from bzrlib.cleanup import OperationWithCleanups
@@ -64,13 +72,20 @@
                            StrictCommitFailed
                            )
 from bzrlib.osutils import (get_user_encoding,
-                            is_inside_any,
+                            kind_marker, isdir,isfile, is_inside_any,
+                            is_inside_or_parent_of_any,
                             minimum_path_selection,
+                            quotefn, sha_file, split_lines,
                             splitpath,
                             )
-from bzrlib.trace import mutter, note, is_quiet
+from bzrlib.testament import Testament
+from bzrlib.trace import mutter, note, warning, is_quiet
 from bzrlib.inventory import Inventory, InventoryEntry, make_entry
 from bzrlib import symbol_versioning
+from bzrlib.symbol_versioning import (deprecated_passed,
+        deprecated_function,
+        DEPRECATED_PARAMETER)
+from bzrlib.workingtree import WorkingTree
 from bzrlib.urlutils import unescape_for_display
 import bzrlib.ui
 

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2010-04-30 11:35:43 +0000
+++ bzrlib/conflicts.py	2010-04-02 19:12:58 +0000
@@ -18,6 +18,7 @@
 # point down
 
 import os
+import re
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2010-04-30 11:35:43 +0000
+++ bzrlib/delta.py	2010-03-19 23:58:06 +0000
@@ -15,9 +15,12 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 from bzrlib import (
+    errors,
     osutils,
     )
-from bzrlib.trace import is_quiet
+from bzrlib.inventory import InventoryEntry
+from bzrlib.trace import mutter, is_quiet
+from bzrlib.symbol_versioning import deprecated_function
 
 
 class TreeDelta(object):

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2010-04-30 11:35:43 +0000
+++ bzrlib/diff.py	2010-04-19 04:10:53 +0000
@@ -17,6 +17,7 @@
 import difflib
 import os
 import re
+import shutil
 import string
 import sys
 

=== modified file 'bzrlib/externalcommand.py'
--- bzrlib/externalcommand.py	2010-04-30 11:03:59 +0000
+++ bzrlib/externalcommand.py	2009-03-23 14:59:43 +0000
@@ -20,8 +20,10 @@
 
 
 import os
+import sys
 
 from bzrlib.commands import Command
+from bzrlib.osutils import pathjoin
 
 
 class ExternalCommand(Command):

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2010-04-30 11:35:43 +0000
+++ bzrlib/fetch.py	2010-03-21 21:39:33 +0000
@@ -35,6 +35,7 @@
 import bzrlib
 from bzrlib import (
     errors,
+    symbol_versioning,
     ui,
     )
 from bzrlib.revision import NULL_REVISION

=== modified file 'bzrlib/foreign.py'
--- bzrlib/foreign.py	2010-04-28 10:33:44 +0000
+++ bzrlib/foreign.py	2010-04-20 22:38:03 +0000
@@ -297,10 +297,8 @@
             source_branch = Branch.open(directory)
             source_wt = None
         if source_wt is not None:
-            source_wt.check_changed_or_out_of_date(
-                strict, 'dpush_strict',
-                more_error='Use --no-strict to force the push.',
-                more_warning='Uncommitted changes will not be pushed.')
+            source_wt.warn_if_changed_or_out_of_date(
+                strict, 'dpush_strict', 'Use --no-strict to force the push.')
         stored_loc = source_branch.get_push_location()
         if location is None:
             if stored_loc is None:

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2010-04-30 11:03:59 +0000
+++ bzrlib/help.py	2010-02-17 17:11:16 +0000
@@ -30,6 +30,7 @@
     help_topics,
     osutils,
     plugin,
+    symbol_versioning,
     )
 
 

=== modified file 'bzrlib/hooks.py'
--- bzrlib/hooks.py	2010-04-30 11:03:59 +0000
+++ bzrlib/hooks.py	2010-03-12 19:59:50 +0000
@@ -18,6 +18,7 @@
 """Support for plugin hooking logic."""
 from bzrlib import registry
 from bzrlib.lazy_import import lazy_import
+from bzrlib.symbol_versioning import deprecated_method
 lazy_import(globals(), """
 import textwrap
 

=== modified file 'bzrlib/identitymap.py'
--- bzrlib/identitymap.py	2010-04-30 11:03:59 +0000
+++ bzrlib/identitymap.py	2009-03-23 14:59:43 +0000
@@ -20,6 +20,7 @@
 
 from bzrlib import (
     errors,
+    osutils,
     )
 
 

=== modified file 'bzrlib/ignores.py'
--- bzrlib/ignores.py	2010-04-30 07:54:33 +0000
+++ bzrlib/ignores.py	2010-04-26 13:51:08 +0000
@@ -176,11 +176,10 @@
 
 
 def tree_ignores_add_patterns(tree, name_pattern_list):
-    """Add more ignore patterns to the ignore file in a tree.
-    If ignore file does not exist then it will be created.
-    The ignore file will be automatically added under version control.
+    """Retrieve a list of ignores from the ignore file in a tree.
 
-    :param tree: Working tree to update the ignore list.
+    :param tree: Tree to retrieve the ignore list from.
+    :return:
     """
     ifn = tree.abspath(bzrlib.IGNORE_FILENAME)
     if tree.has_filename(ifn):
@@ -207,5 +206,5 @@
     finally:
         f.close()
 
-    if not tree.path2id(bzrlib.IGNORE_FILENAME):
-        tree.add([bzrlib.IGNORE_FILENAME])
+    if not tree.path2id('.bzrignore'):
+        tree.add(['.bzrignore'])

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2010-04-30 11:35:43 +0000
+++ bzrlib/info.py	2010-04-21 09:57:18 +0000
@@ -17,11 +17,13 @@
 __all__ = ['show_bzrdir_info']
 
 from cStringIO import StringIO
+import os
 import time
 import sys
 
 from bzrlib import (
     bzrdir,
+    diff,
     errors,
     hooks as _mod_hooks,
     osutils,

=== modified file 'bzrlib/lockable_files.py'
--- bzrlib/lockable_files.py	2010-04-30 11:03:59 +0000
+++ bzrlib/lockable_files.py	2009-10-15 02:11:18 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+from cStringIO import StringIO
+
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import codecs
@@ -32,6 +34,10 @@
 from bzrlib.decorators import (
     only_raises,
     )
+from bzrlib.symbol_versioning import (
+    deprecated_in,
+    deprecated_method,
+    )
 
 
 # XXX: The tracking here of lock counts and whether the lock is held is

=== modified file 'bzrlib/memorytree.py'
--- bzrlib/memorytree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/memorytree.py	2009-04-09 20:23:07 +0000
@@ -25,9 +25,10 @@
 from bzrlib import (
     errors,
     mutabletree,
+    osutils,
     revision as _mod_revision,
     )
-from bzrlib.decorators import needs_read_lock
+from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.osutils import sha_file
 from bzrlib.mutabletree import needs_tree_write_lock
 from bzrlib.transport.memory import MemoryTransport

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2010-05-03 04:08:50 +0000
+++ bzrlib/merge.py	2010-04-26 23:36:26 +0000
@@ -93,60 +93,7 @@
         return ('not applicable', None)
 
 
-class PerFileMerger(AbstractPerFileMerger):
-    """Merge individual files when self.file_matches returns True.
-
-    This class is intended to be subclassed.  The file_matches and
-    merge_matching methods should be overridden with concrete implementations.
-    """
-
-    def file_matches(self, params):
-        """Return True if merge_matching should be called on this file.
-
-        Only called with merges of plain files with no clear winner.
-
-        Subclasses must override this.
-        """
-        raise NotImplementedError(self.file_matches)
-
-    def get_filename(self, params, tree):
-        """Lookup the filename (i.e. basename, not path), given a Tree (e.g.
-        self.merger.this_tree) and a MergeHookParams.
-        """
-        return osutils.basename(tree.id2path(params.file_id))
-
-    def get_filepath(self, params, tree):
-        """Calculate the path to the file in a tree.
-
-        :param params: A MergeHookParams describing the file to merge
-        :param tree: a Tree, e.g. self.merger.this_tree.
-        """
-        return tree.id2path(params.file_id)
-
-    def merge_contents(self, params):
-        """Merge the contents of a single file."""
-        # Check whether this custom merge logic should be used.
-        if (
-            # OTHER is a straight winner, rely on default merge.
-            params.winner == 'other' or
-            # THIS and OTHER aren't both files.
-            not params.is_file_merge() or
-            # The filename doesn't match *.xml
-            not self.file_matches(params)):
-            return 'not_applicable', None
-        return self.merge_matching(params)
-
-    def merge_matching(self, params):
-        """Merge the contents of a single file that has matched the criteria
-        in PerFileMerger.merge_contents (is a conflict, is a file,
-        self.file_matches is True).
-
-        Subclasses must override this.
-        """
-        raise NotImplementedError(self.merge_matching)
-
-
-class ConfigurableFileMerger(PerFileMerger):
+class ConfigurableFileMerger(AbstractPerFileMerger):
     """Merge individual files when configured via a .conf file.
 
     This is a base class for concrete custom file merging logic. Concrete
@@ -175,7 +122,7 @@
         if self.name_prefix is None:
             raise ValueError("name_prefix must be set.")
 
-    def file_matches(self, params):
+    def filename_matches_config(self, params):
         """Check whether the file should call the merge hook.
 
         <name_prefix>_merge_files configuration variable is a list of files
@@ -195,12 +142,24 @@
                 affected_files = self.default_files
             self.affected_files = affected_files
         if affected_files:
-            filepath = self.get_filepath(params, self.merger.this_tree)
-            if filepath in affected_files:
+            filename = self.merger.this_tree.id2path(params.file_id)
+            if filename in affected_files:
                 return True
         return False
 
-    def merge_matching(self, params):
+    def merge_contents(self, params):
+        """Merge the contents of a single file."""
+        # First, check whether this custom merge logic should be used.  We
+        # expect most files should not be merged by this handler.
+        if (
+            # OTHER is a straight winner, rely on default merge.
+            params.winner == 'other' or
+            # THIS and OTHER aren't both files.
+            not params.is_file_merge() or
+            # The filename isn't listed in the 'NAME_merge_files' config
+            # option.
+            not self.filename_matches_config(params)):
+            return 'not_applicable', None
         return self.merge_text(params)
 
     def merge_text(self, params):

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2010-04-30 11:03:59 +0000
+++ bzrlib/missing.py	2009-08-17 18:52:01 +0000
@@ -18,6 +18,8 @@
 
 from bzrlib import (
     log,
+    repository as _mod_repository,
+    tsort,
     )
 import bzrlib.revision as _mod_revision
 

=== modified file 'bzrlib/msgeditor.py'
--- bzrlib/msgeditor.py	2010-04-30 11:35:43 +0000
+++ bzrlib/msgeditor.py	2010-04-07 22:22:27 +0000
@@ -18,6 +18,7 @@
 """Commit message editor support."""
 
 import codecs
+import errno
 import os
 from subprocess import call
 import sys

=== modified file 'bzrlib/mutabletree.py'
--- bzrlib/mutabletree.py	2010-04-22 14:18:17 +0000
+++ bzrlib/mutabletree.py	2010-04-15 06:47:06 +0000
@@ -258,8 +258,7 @@
             return False
 
     @needs_read_lock
-    def check_changed_or_out_of_date(self, strict, opt_name,
-                                     more_error, more_warning):
+    def warn_if_changed_or_out_of_date(self, strict, opt_name, more_msg):
         """Check the tree for uncommitted changes and branch synchronization.
 
         If strict is None and not set in the config files, a warning is issued.
@@ -270,29 +269,25 @@
 
         :param opt_name: strict option name to search in config file.
 
-        :param more_error: Details about how to avoid the check.
-
-        :param more_warning: Details about what is happening.
+        :param more_msg: Details about how to avoid the warnings.
         """
         if strict is None:
             strict = self.branch.get_config().get_user_option_as_bool(opt_name)
         if strict is not False:
-            err_class = None
+            err = None
             if (self.has_changes()):
-                err_class = errors.UncommittedChanges
+                err = errors.UncommittedChanges(self, more=more_msg)
             elif self.last_revision() != self.branch.last_revision():
                 # The tree has lost sync with its branch, there is little
                 # chance that the user is aware of it but he can still force
                 # the action with --no-strict
-                err_class = errors.OutOfDateTree
-            if err_class is not None:
+                err = errors.OutOfDateTree(self, more=more_msg)
+            if err is not None:
                 if strict is None:
-                    err = err_class(self, more=more_warning)
                     # We don't want to interrupt the user if he expressed no
                     # preference about strict.
                     trace.warning('%s', err._format())
                 else:
-                    err = err_class(self, more=more_error)
                     raise err
 
     @needs_read_lock

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2010-04-20 08:47:38 +0000
+++ bzrlib/option.py	2010-04-13 04:33:55 +0000
@@ -276,7 +276,7 @@
         parser.add_option(action='callback',
                           callback=self._optparse_callback,
                           type='string', metavar=self.argname.upper(),
-                          help=self.help, dest=self._param_name, default=[],
+                          help=self.help, default=[],
                           *option_strings)
 
     def _optparse_callback(self, option, opt, value, parser):

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2010-05-03 06:25:46 +0000
+++ bzrlib/osutils.py	2010-04-24 09:08:27 +0000
@@ -17,10 +17,12 @@
 import os
 import re
 import stat
-from stat import S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE
+from stat import (S_ISREG, S_ISDIR, S_ISLNK, ST_MODE, ST_SIZE,
+                  S_ISCHR, S_ISBLK, S_ISFIFO, S_ISSOCK)
 import sys
 import time
 import codecs
+import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -360,14 +362,6 @@
     return _win32_fixdrive(tempfile.mkdtemp(*args, **kwargs).replace('\\', '/'))
 
 
-def _add_rename_error_details(e, old, new):
-    new_e = OSError(e.errno, "failed to rename %s to %s: %s"
-        % (old, new, e.strerror))
-    new_e.filename = old
-    new_e.to_filename = new
-    return new_e
-
-
 def _win32_rename(old, new):
     """We expect to be able to atomically replace 'new' with old.
 
@@ -375,7 +369,7 @@
     and then deleted.
     """
     try:
-        fancy_rename(old, new, rename_func=_wrapped_rename, unlink_func=os.unlink)
+        fancy_rename(old, new, rename_func=os.rename, unlink_func=os.unlink)
     except OSError, e:
         if e.errno in (errno.EPERM, errno.EACCES, errno.EBUSY, errno.EINVAL):
             # If we try to rename a non-existant file onto cwd, we get
@@ -386,16 +380,6 @@
         raise
 
 
-def _wrapped_rename(old, new):
-    """Rename a file or directory"""
-    try:
-        os.rename(old, new)
-    except (IOError, OSError), e:
-        # this is eventually called by all rename-like functions, so should 
-        # catch all of them
-        raise _add_rename_error_details(e, old, new)
-
-
 def _mac_getcwd():
     return unicodedata.normalize('NFC', os.getcwdu())
 
@@ -406,8 +390,8 @@
 realpath = _posix_realpath
 pathjoin = os.path.join
 normpath = os.path.normpath
-rename = _wrapped_rename # overridden below on win32
 getcwd = os.getcwdu
+rename = os.rename
 dirname = os.path.dirname
 basename = os.path.basename
 split = os.path.split
@@ -1147,7 +1131,7 @@
 
 
 def relpath(base, path):
-    """Return path relative to base, or raise PathNotChild exception.
+    """Return path relative to base, or raise exception.
 
     The path may be either an absolute path or a path relative to the
     current working directory.
@@ -1155,9 +1139,6 @@
     os.path.commonprefix (python2.4) has a bad bug that it works just
     on string prefixes, assuming that '/u' is a prefix of '/u2'.  This
     avoids that problem.
-
-    NOTE: `base` should not have a trailing slash otherwise you'll get
-    PathNotChild exceptions regardless of `path`.
     """
 
     if len(base) < MIN_ABS_PATHLENGTH:

=== modified file 'bzrlib/plugins/launchpad/lp_directory.py'
--- bzrlib/plugins/launchpad/lp_directory.py	2010-03-30 11:05:14 +0000
+++ bzrlib/plugins/launchpad/lp_directory.py	2010-02-17 17:11:16 +0000
@@ -17,13 +17,14 @@
 
 """Directory lookup that uses Launchpad."""
 
-from urlparse import urlsplit
+from urlparse import urlsplit, urlunsplit
 import xmlrpclib
 
 from bzrlib import (
     debug,
     errors,
     trace,
+    urlutils,
     )
 from bzrlib.transport import (
     get_transport,

=== modified file 'bzrlib/plugins/news_merge/__init__.py'
--- bzrlib/plugins/news_merge/__init__.py	2010-05-03 04:08:50 +0000
+++ bzrlib/plugins/news_merge/__init__.py	2010-04-16 12:59:03 +0000
@@ -21,6 +21,7 @@
 
     [/home/user/code/bzr]
     news_merge_files = NEWS
+    news_merge_files:policy = recurse
 
 The news_merge_files config option takes a list of file paths, separated by
 commas.

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2010-04-30 11:03:59 +0000
+++ bzrlib/progress.py	2010-02-25 06:42:33 +0000
@@ -27,7 +27,12 @@
 import os
 
 
+from bzrlib import (
+    errors,
+    )
+from bzrlib.trace import mutter
 from bzrlib.symbol_versioning import (
+    deprecated_function,
     deprecated_in,
     deprecated_method,
     )

=== modified file 'bzrlib/push.py'
--- bzrlib/push.py	2010-04-30 11:03:59 +0000
+++ bzrlib/push.py	2010-02-16 16:08:40 +0000
@@ -17,6 +17,8 @@
 """UI helper for the push command."""
 
 from bzrlib import (
+    builtins,
+    branch,
     bzrdir,
     errors,
     revision as _mod_revision,

=== modified file 'bzrlib/reconcile.py'
--- bzrlib/reconcile.py	2010-04-30 11:35:43 +0000
+++ bzrlib/reconcile.py	2010-04-23 00:44:15 +0000
@@ -30,6 +30,7 @@
     cleanup,
     errors,
     ui,
+    repository,
     )
 from bzrlib.trace import mutter
 from bzrlib.tsort import topo_sort

=== modified file 'bzrlib/revisiontree.py'
--- bzrlib/revisiontree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/revisiontree.py	2010-02-17 17:11:16 +0000
@@ -20,7 +20,9 @@
 
 from bzrlib import (
     errors,
+    osutils,
     revision,
+    symbol_versioning,
     tree,
     )
 

=== modified file 'bzrlib/send.py'
--- bzrlib/send.py	2010-04-22 14:18:17 +0000
+++ bzrlib/send.py	2010-04-12 16:54:35 +0000
@@ -111,10 +111,8 @@
                 base_revision_id = revision[0].as_revision_id(branch)
         if revision_id is None:
             if tree is not None:
-                tree.check_changed_or_out_of_date(
-                    strict, 'send_strict',
-                    more_error='Use --no-strict to force the send.',
-                    more_warning='Uncommitted changes will not be sent.')
+                tree.warn_if_changed_or_out_of_date(
+                    strict, 'send_strict', 'Use --no-strict to force the send.')
             revision_id = branch.last_revision()
         if revision_id == NULL_REVISION:
             raise errors.BzrCommandError('No revisions to submit.')

=== modified file 'bzrlib/shelf.py'
--- bzrlib/shelf.py	2010-04-30 11:03:59 +0000
+++ bzrlib/shelf.py	2009-09-11 07:55:48 +0000
@@ -23,8 +23,11 @@
     errors,
     merge,
     merge3,
+    osutils,
     pack,
     transform,
+    ui,
+    workingtree,
 )
 
 

=== modified file 'bzrlib/smart/medium.py'
--- bzrlib/smart/medium.py	2010-05-03 04:08:50 +0000
+++ bzrlib/smart/medium.py	2010-03-18 23:11:15 +0000
@@ -607,16 +607,10 @@
             # which is newer than a previously supplied older-than version.
             # This indicates that some smart verb call is not guarded
             # appropriately (it should simply not have been tried).
-            trace.mutter(
+            raise AssertionError(
                 "_remember_remote_is_before(%r) called, but "
                 "_remember_remote_is_before(%r) was called previously."
-                , version_tuple, self._remote_version_is_before)
-            if 'hpss' in debug.debug_flags:
-                ui.ui_factory.show_warning(
-                    "_remember_remote_is_before(%r) called, but "
-                    "_remember_remote_is_before(%r) was called previously."
-                    % (version_tuple, self._remote_version_is_before))
-            return
+                % (version_tuple, self._remote_version_is_before))
         self._remote_version_is_before = version_tuple
 
     def protocol_version(self):

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2010-04-30 11:35:43 +0000
+++ bzrlib/status.py	2010-04-15 20:22:04 +0000
@@ -20,10 +20,14 @@
     delta as _mod_delta,
     log,
     osutils,
+    tree,
     tsort,
     revision as _mod_revision,
     )
 import bzrlib.errors as errors
+from bzrlib.osutils import is_inside_any
+from bzrlib.symbol_versioning import (deprecated_function,
+        )
 from bzrlib.trace import mutter, warning
 
 # TODO: when showing single-line logs, truncate to the width of the terminal

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-05-06 07:48:22 +0000
+++ bzrlib/tests/__init__.py	2010-04-23 16:22:41 +0000
@@ -3734,7 +3734,6 @@
         'bzrlib.tests.test_lru_cache',
         'bzrlib.tests.test_lsprof',
         'bzrlib.tests.test_mail_client',
-        'bzrlib.tests.test_matchers',
         'bzrlib.tests.test_memorytree',
         'bzrlib.tests.test_merge',
         'bzrlib.tests.test_merge3',

=== modified file 'bzrlib/tests/blackbox/test_dpush.py'
--- bzrlib/tests/blackbox/test_dpush.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_dpush.py	2010-04-13 06:42:19 +0000
@@ -153,6 +153,24 @@
         conf.set_user_option('dpush_strict', value)
 
     _default_command = ['dpush', '../to']
+    _default_pushed_revid = False # Doesn't aplly for dpush
+
+    def assertPushSucceeds(self, args, pushed_revid=None, with_warning=False):
+        if with_warning:
+            error_regexes = self._default_errors
+        else:
+            error_regexes = []
+        self.run_bzr(self._default_command + args,
+                     working_dir=self._default_wd, error_regexes=error_regexes)
+        if pushed_revid is None:
+            # dpush change the revids, so we need to get back to it
+            branch_from = branch.Branch.open(self._default_wd)
+            pushed_revid = branch_from.last_revision()
+        branch_to = branch.Branch.open('to')
+        repo_to = branch_to.repository
+        self.assertTrue(repo_to.has_revision(pushed_revid))
+        self.assertEqual(branch_to.last_revision(), pushed_revid)
+
 
 
 class TestDpushStrictWithoutChanges(TestDpushStrictMixin,

=== modified file 'bzrlib/tests/blackbox/test_filesystem_cicp.py'
--- bzrlib/tests/blackbox/test_filesystem_cicp.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_filesystem_cicp.py	2009-08-26 09:06:02 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2010 Canonical Ltd
+# Copyright (C) 2008 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,8 +19,6 @@
 
 import os
 
-from bzrlib import (osutils,
-    )
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.tests import CaseInsCasePresFilenameFeature, KnownFailure
 from bzrlib.osutils import canonical_relpath, pathjoin
@@ -91,7 +89,7 @@
         self.build_tree(['MixedCase'])
         self.check_output('adding MixedCase\n', 'add MixedCase')
         # 'accidently' rename the file on disk
-        osutils.rename('MixedCase', 'mixedcase')
+        os.rename('MixedCase', 'mixedcase')
         self.check_empty_output('add mixedcase')
 
     def test_re_add_dir(self):
@@ -105,7 +103,7 @@
                           'adding MixedCaseParent/MixedCase\n',
                           'add MixedCaseParent')
         # 'accidently' rename the directory on disk
-        osutils.rename('MixedCaseParent', 'mixedcaseparent')
+        os.rename('MixedCaseParent', 'mixedcaseparent')
         self.check_empty_output('add mixedcaseparent')
 
     def test_add_not_found(self):
@@ -132,7 +130,7 @@
         wt = self._make_mixed_case_tree()
         self.run_bzr('add')
         self.run_bzr('ci -m message')
-        osutils.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/NewCamelCase')
+        os.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/NewCamelCase')
 
         # In this case we can specify the incorrect case for the destination,
         # as we use --after, so the file-system is sniffed.
@@ -159,7 +157,7 @@
         # Remove the source and create a destination file on disk with a different case.
         # bzr should report that the filename is already versioned.
         os.unlink('CamelCaseParent/CamelCase')
-        osutils.rename('lowercaseparent/lowercase', 'lowercaseparent/LOWERCASE')
+        os.rename('lowercaseparent/lowercase', 'lowercaseparent/LOWERCASE')
         ex = 'bzr: ERROR: Could not move CamelCase => lowercase: lowercaseparent/lowercase is already versioned.\n'
         self.check_error_output(3, ex, 'mv --after camelcaseparent/camelcase LOWERCASEPARENT/LOWERCASE')
 
@@ -175,7 +173,7 @@
         wt = self._make_mixed_case_tree()
         self.run_bzr('add')
         self.run_bzr('ci -m message')
-        osutils.rename('CamelCaseParent', 'NewCamelCaseParent')
+        os.rename('CamelCaseParent', 'NewCamelCaseParent')
 
         # In this case we can specify the incorrect case for the destination,
         # as we use --after, so the file-system is sniffed.
@@ -201,7 +199,7 @@
 
         # perform a mv to the new case - we must ensure the file-system has the
         # new case first.
-        osutils.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/camelCase')
+        os.rename('CamelCaseParent/CamelCase', 'CamelCaseParent/camelCase')
         self.check_output('CamelCaseParent/CamelCase => CamelCaseParent/camelCase\n',
                           'mv --after camelcaseparent/camelcase camelcaseparent/camelCase')
         # bzr should not have renamed the file to a different case

=== modified file 'bzrlib/tests/blackbox/test_join.py'
--- bzrlib/tests/blackbox/test_join.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_join.py	2009-03-23 14:59:43 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006, 2010 Canonical Ltd
+# Copyright (C) 2006 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -17,13 +17,7 @@
 
 import os
 
-from bzrlib import (
-    bzrdir,
-    osutils,
-    repository,
-    tests,
-    workingtree,
-    )
+from bzrlib import bzrdir, repository, tests, workingtree
 
 
 class TestJoin(tests.TestCaseWithTransport):
@@ -56,7 +50,7 @@
     def test_join_error(self):
         base_tree, sub_tree = self.make_trees()
         os.mkdir('tree/subtree2')
-        osutils.rename('tree/subtree', 'tree/subtree2/subtree')
+        os.rename('tree/subtree', 'tree/subtree2/subtree')
         self.run_bzr_error(
             ('Cannot join .*subtree.  Parent directory is not versioned',),
              'join tree/subtree2/subtree')

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_push.py	2010-04-15 06:47:06 +0000
@@ -661,35 +661,27 @@
     _default_wd = 'local'
     _default_errors = ['Working tree ".*/local/" has uncommitted '
                        'changes \(See bzr status\)\.',]
-    _default_additional_error = 'Use --no-strict to force the push.\n'
-    _default_additional_warning = 'Uncommitted changes will not be pushed.'
-
+    _default_pushed_revid = 'modified'
 
     def assertPushFails(self, args):
-        out, err = self.run_bzr_error(self._default_errors,
-                                      self._default_command + args,
-                                      working_dir=self._default_wd, retcode=3)
-        self.assertContainsRe(err, self._default_additional_error)
+        ret = self.run_bzr_error(self._default_errors,
+                                 self._default_command + args,
+                                 working_dir=self._default_wd, retcode=3)
 
-    def assertPushSucceeds(self, args, with_warning=False, revid_to_push=None):
+    def assertPushSucceeds(self, args, pushed_revid=None, with_warning=False):
         if with_warning:
             error_regexes = self._default_errors
         else:
             error_regexes = []
-        out, err = self.run_bzr(self._default_command + args,
-                                working_dir=self._default_wd,
-                                error_regexes=error_regexes)
-        if with_warning:
-            self.assertContainsRe(err, self._default_additional_warning)
-        else:
-            self.assertNotContainsRe(err, self._default_additional_warning)
-        branch_from = branch.Branch.open(self._default_wd)
-        if revid_to_push is None:
-            revid_to_push = branch_from.last_revision()
-        branch_to = branch.Branch.open('to')
-        repo_to = branch_to.repository
-        self.assertTrue(repo_to.has_revision(revid_to_push))
-        self.assertEqual(revid_to_push, branch_to.last_revision())
+        ret = self.run_bzr(self._default_command + args,
+                           working_dir=self._default_wd,
+                           error_regexes=error_regexes)
+        if pushed_revid is None:
+            pushed_revid = self._default_pushed_revid
+        tree_to = workingtree.WorkingTree.open('to')
+        repo_to = tree_to.branch.repository
+        self.assertTrue(repo_to.has_revision(pushed_revid))
+        self.assertEqual(tree_to.branch.last_revision_info()[1], pushed_revid)
 
 
 
@@ -756,12 +748,13 @@
         self._default_wd = 'checkout'
         self._default_errors = ["Working tree is out of date, please run"
                                 " 'bzr update'\.",]
+        self._default_pushed_revid = 'modified-in-local'
 
     def test_push_default(self):
         self.assertPushSucceeds([], with_warning=True)
 
     def test_push_with_revision(self):
-        self.assertPushSucceeds(['-r', 'revid:added'], revid_to_push='added')
+        self.assertPushSucceeds(['-r', 'revid:added'], pushed_revid='added')
 
     def test_push_no_strict(self):
         self.assertPushSucceeds(['--no-strict'])

=== modified file 'bzrlib/tests/blackbox/test_send.py'
--- bzrlib/tests/blackbox/test_send.py	2010-04-28 10:30:48 +0000
+++ bzrlib/tests/blackbox/test_send.py	2010-04-12 16:41:03 +0000
@@ -307,8 +307,6 @@
     _default_sent_revs = ['local']
     _default_errors = ['Working tree ".*/local/" has uncommitted '
                        'changes \(See bzr status\)\.',]
-    _default_additional_error = 'Use --no-strict to force the send.\n'
-    _default_additional_warning = 'Uncommitted changes will not be sent.'
 
     def set_config_send_strict(self, value):
         # set config var (any of bazaar.conf, locations.conf, branch.conf
@@ -317,8 +315,7 @@
         conf.set_user_option('send_strict', value)
 
     def assertSendFails(self, args):
-        out, err = self.run_send(args, rc=3, err_re=self._default_errors)
-        self.assertContainsRe(err, self._default_additional_error)
+        self.run_send(args, rc=3, err_re=self._default_errors)
 
     def assertSendSucceeds(self, args, revs=None, with_warning=False):
         if with_warning:
@@ -330,7 +327,6 @@
         out, err = self.run_send(args, err_re=err_re)
         bundling_revs = 'Bundling %d revision(s).\n' % len(revs)
         if with_warning:
-            self.assertContainsRe(err, self._default_additional_warning)
             self.assertEndsWith(err, bundling_revs)
         else:
             self.assertEquals(bundling_revs, err)

=== modified file 'bzrlib/tests/blackbox/test_switch.py'
--- bzrlib/tests/blackbox/test_switch.py	2010-04-28 07:53:34 +0000
+++ bzrlib/tests/blackbox/test_switch.py	2010-03-26 07:08:56 +0000
@@ -20,7 +20,6 @@
 
 import os
 
-from bzrlib import osutils
 from bzrlib.workingtree import WorkingTree
 from bzrlib.tests.blackbox import ExternalBase
 from bzrlib.directory_service import directories
@@ -168,7 +167,7 @@
     def prepare_lightweight_switch(self):
         branch = self.make_branch('branch')
         branch.create_checkout('tree', lightweight=True)
-        osutils.rename('branch', 'branch1')
+        os.rename('branch', 'branch1')
 
     def test_switch_lightweight_after_branch_moved(self):
         self.prepare_lightweight_switch()

=== removed file 'bzrlib/tests/matchers.py'
--- bzrlib/tests/matchers.py	2010-05-06 07:48:22 +0000
+++ bzrlib/tests/matchers.py	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Matchers for bzrlib.
-
-Primarily test support, Matchers are used by self.assertThat in the bzrlib
-test suite. A matcher is a stateful test helper which can be used to determine
-if a passed object 'matches', much like a regex. If the object does not match
-the mismatch can be described in a human readable fashion. assertThat then
-raises if a mismatch occurs, showing the description as the assertion error.
-
-Matchers are designed to be more reusable and composable than layered
-assertions in Test Case objects, so they are recommended for new testing work.
-"""
-
-__all__ = [
-    'ReturnsCallableLeavingObjectUnlocked',
-    ]
-
-from testtools.matchers import Mismatch, Matcher
-
-
-class ReturnsCallableLeavingObjectUnlocked(Matcher):
-    """A matcher that checks for the pattern we want lock* methods to have:
-
-    They should return a callable.
-    Calling that callable should unlock the original object.
-
-    :ivar lockable_thing: The object which can be locked that will be
-        inspected.
-    """
-
-    def __init__(self, lockable_thing):
-        Matcher.__init__(self)
-        self.lockable_thing = lockable_thing
-
-    def __str__(self):
-        return ('ReturnsCallableLeavingObjectUnlocked(lockable_thing=%s)' % 
-            self.lockable_thing)
-
-    def match(self, lock_method):
-        lock_method()()
-        if self.lockable_thing.is_locked():
-            return _IsLocked(self.lockable_thing)
-        return None
-
-
-class _IsLocked(Mismatch):
-    """Something is locked."""
-
-    def __init__(self, lockable_thing):
-        self.lockable_thing = lockable_thing
-
-    def describe(self):
-        return "%s is locked" % self.lockable_thing

=== modified file 'bzrlib/tests/per_repository_chk/__init__.py'
--- bzrlib/tests/per_repository_chk/__init__.py	2010-03-31 16:29:25 +0000
+++ bzrlib/tests/per_repository_chk/__init__.py	2009-09-08 06:25:26 +0000
@@ -27,6 +27,7 @@
     repository,
     remote,
     )
+from bzrlib.bzrdir import BzrDir
 from bzrlib.repofmt.pack_repo import (
     RepositoryFormatKnitPack5,
     )
@@ -35,6 +36,7 @@
     )
 from bzrlib.tests import (
     multiply_tests,
+    TestSuite,
     )
 from bzrlib.tests.per_repository import (
     all_repository_format_scenarios,

=== modified file 'bzrlib/tests/per_repository_reference/test_default_stacking.py'
--- bzrlib/tests/per_repository_reference/test_default_stacking.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/per_repository_reference/test_default_stacking.py	2010-04-26 13:51:08 +0000
@@ -15,10 +15,10 @@
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
 
-from bzrlib.tests.per_repository import TestCaseWithRepository
-
-
-class TestDefaultStackingPolicy(TestCaseWithRepository):
+from bzrlib.tests import per_repository
+
+
+class TestDefaultStackingPolicy(per_repository.TestCaseWithRepository):
 
     def test_sprout_to_smart_server_stacking_policy_handling(self):
         """Obey policy where possible, ignore otherwise."""

=== removed file 'bzrlib/tests/test_matchers.py'
--- bzrlib/tests/test_matchers.py	2010-05-06 07:48:22 +0000
+++ bzrlib/tests/test_matchers.py	1970-01-01 00:00:00 +0000
@@ -1,57 +0,0 @@
-# Copyright (C) 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests of bzrlib test matchers."""
-
-from testtools.matchers import *
-
-from bzrlib.tests import TestCase
-from bzrlib.tests.matchers import *
-
-
-class StubTree(object):
-    """Stubg for testing."""
-
-    def __init__(self, lock_status):
-        self._is_locked = lock_status
-
-    def __str__(self):
-        return u'I am da tree'
-
-    def is_locked(self):
-        return self._is_locked
-
-
-class TestReturnsCallableLeavingObjectUnlocked(TestCase):
-
-    def test___str__(self):
-        matcher = ReturnsCallableLeavingObjectUnlocked(StubTree(True))
-        self.assertEqual(
-            'ReturnsCallableLeavingObjectUnlocked(lockable_thing=I am da tree)',
-            str(matcher))
-
-    def test_match(self):
-        stub_tree = StubTree(False)
-        matcher = ReturnsCallableLeavingObjectUnlocked(stub_tree)
-        self.assertThat(matcher.match(lambda:lambda:None), Equals(None))
-
-    def test_mismatch(self):
-        stub_tree = StubTree(True)
-        matcher = ReturnsCallableLeavingObjectUnlocked(stub_tree)
-        mismatch = matcher.match(lambda:lambda:None)
-        self.assertNotEqual(None, mismatch)
-        self.assertThat(mismatch.describe(), Equals("I am da tree is locked"))
-

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2010-04-20 08:47:38 +0000
+++ bzrlib/tests/test_options.py	2009-05-23 21:01:51 +0000
@@ -318,13 +318,6 @@
         self.assertEqual('hello', name)
         self.assertEqual([], value)
 
-    def test_list_option_param_name(self):
-        """Test list options can have their param_name set."""
-        options = [option.ListOption('hello', type=str, param_name='greeting')]
-        opts, args = self.parse(
-            options, ['--hello=world', '--hello=sailor'])
-        self.assertEqual(['world', 'sailor'], opts.greeting)
-
 
 class TestOptionDefinitions(TestCase):
     """Tests for options in the Bazaar codebase."""

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2010-04-27 07:52:08 +0000
+++ bzrlib/tests/test_osutils.py	2010-04-24 13:48:58 +0000
@@ -184,13 +184,6 @@
         shape = sorted(os.listdir('.'))
         self.assertEquals(['A', 'B'], shape)
 
-    def test_rename_error(self):
-        # We wrap os.rename to make it give an error including the filenames
-        # https://bugs.launchpad.net/bzr/+bug/491763
-        err = self.assertRaises(OSError, osutils.rename,
-            'nonexistent', 'target')
-        self.assertContainsString(str(err), 'nonexistent')
-
 
 class TestRandChars(tests.TestCase):
 

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2010-05-03 04:08:50 +0000
+++ bzrlib/tests/test_remote.py	2010-04-20 00:20:00 +0000
@@ -418,12 +418,9 @@
         # Calling _remember_remote_is_before again with a lower value works.
         client_medium._remember_remote_is_before((1, 5))
         self.assertTrue(client_medium._is_remote_before((1, 5)))
-        # If you call _remember_remote_is_before with a higher value it logs a
-        # warning, and continues to remember the lower value.
-        self.assertNotContainsRe(self.get_log(), '_remember_remote_is_before')
-        client_medium._remember_remote_is_before((1, 9))
-        self.assertContainsRe(self.get_log(), '_remember_remote_is_before')
-        self.assertTrue(client_medium._is_remote_before((1, 5)))
+        # You cannot call _remember_remote_is_before with a larger value.
+        self.assertRaises(
+            AssertionError, client_medium._remember_remote_is_before, (1, 9))
 
 
 class TestBzrDirCloningMetaDir(TestRemote):
@@ -531,28 +528,6 @@
         self.assertIsInstance(bd, RemoteBzrDir)
         self.assertFinished(client)
 
-    def test_backwards_compat_hpss_v2(self):
-        client, transport = self.make_fake_client_and_transport()
-        # Monkey-patch fake client to simulate real-world behaviour with v2
-        # server: upon first RPC call detect the protocol version, and because
-        # the version is 2 also do _remember_remote_is_before((1, 6)) before
-        # continuing with the RPC.
-        orig_check_call = client._check_call
-        def check_call(method, args):
-            client._medium._protocol_version = 2
-            client._medium._remember_remote_is_before((1, 6))
-            client._check_call = orig_check_call
-            client._check_call(method, args)
-        client._check_call = check_call
-        client.add_expected_call(
-            'BzrDir.open_2.1', ('quack/',), 'unknown', ('BzrDir.open_2.1',))
-        client.add_expected_call(
-            'BzrDir.open', ('quack/',), 'success', ('yes',))
-        bd = RemoteBzrDir(transport, remote.RemoteBzrDirFormat(),
-            _client=client, _force_probe=True)
-        self.assertIsInstance(bd, RemoteBzrDir)
-        self.assertFinished(client)
-
 
 class TestBzrDirOpenBranch(TestRemote):
 

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2010-03-31 16:29:25 +0000
+++ bzrlib/tests/test_repository.py	2010-02-09 21:03:24 +0000
@@ -23,10 +23,12 @@
 """
 
 from stat import S_ISDIR
+from StringIO import StringIO
 import sys
 
 import bzrlib
-from bzrlib.errors import (NoSuchFile,
+from bzrlib.errors import (NotBranchError,
+                           NoSuchFile,
                            UnknownFormatError,
                            UnsupportedFormatError,
                            )
@@ -34,23 +36,31 @@
     graph,
     tests,
     )
+from bzrlib.branchbuilder import BranchBuilder
 from bzrlib.btree_index import BTreeBuilder, BTreeGraphIndex
-from bzrlib.index import GraphIndex
+from bzrlib.index import GraphIndex, InMemoryGraphIndex
 from bzrlib.repository import RepositoryFormat
+from bzrlib.smart import server
 from bzrlib.tests import (
     TestCase,
     TestCaseWithTransport,
+    TestSkipped,
+    test_knit,
     )
 from bzrlib.transport import (
+    fakenfs,
     get_transport,
     )
 from bzrlib import (
+    bencode,
     bzrdir,
     errors,
     inventory,
     osutils,
+    progress,
     repository,
     revision as _mod_revision,
+    symbol_versioning,
     upgrade,
     versionedfile,
     workingtree,

=== modified file 'bzrlib/textinv.py'
--- bzrlib/textinv.py	2010-04-30 11:03:59 +0000
+++ bzrlib/textinv.py	2009-03-23 14:59:43 +0000
@@ -16,7 +16,7 @@
 
 
 from bzrlib.errors import BzrError
-from bzrlib.inventory import Inventory
+from bzrlib.inventory import InventoryEntry, Inventory
 
 
 START_MARK = "# bzr inventory format 3\n"

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2010-04-30 11:35:43 +0000
+++ bzrlib/transform.py	2010-04-01 12:53:53 +0000
@@ -35,7 +35,7 @@
     )
 """)
 from bzrlib.errors import (DuplicateKey, MalformedTransform, NoSuchFile,
-                           ReusingTransform, CantMoveRoot,
+                           ReusingTransform, NotVersionedError, CantMoveRoot,
                            ExistingLimbo, ImmortalLimbo, NoFinalPath,
                            UnableCreateSymlink)
 from bzrlib.filters import filtered_output_bytes, ContentFilterContext
@@ -1160,7 +1160,7 @@
             if trans_id not in self._new_contents:
                 continue
             new_path = self._limbo_name(trans_id)
-            osutils.rename(old_path, new_path)
+            os.rename(old_path, new_path)
             for descendant in self._limbo_descendants(trans_id):
                 desc_path = self._limbo_files[descendant]
                 desc_path = new_path + desc_path[len(old_path):]
@@ -2898,9 +2898,9 @@
         self.pending_deletions = []
 
     def rename(self, from_, to):
-        """Rename a file from one path to another."""
+        """Rename a file from one path to another.  Functions like os.rename"""
         try:
-            osutils.rename(from_, to)
+            os.rename(from_, to)
         except OSError, e:
             if e.errno in (errno.EEXIST, errno.ENOTEMPTY):
                 raise errors.FileExists(to, str(e))
@@ -2920,7 +2920,7 @@
     def rollback(self):
         """Reverse all renames that have been performed"""
         for from_, to in reversed(self.past_renames):
-            osutils.rename(to, from_)
+            os.rename(to, from_)
         # after rollback, don't reuse _FileMover
         past_renames = None
         pending_deletions = None

=== modified file 'bzrlib/transport/chroot.py'
--- bzrlib/transport/chroot.py	2010-04-07 12:19:40 +0000
+++ bzrlib/transport/chroot.py	2010-02-23 07:43:11 +0000
@@ -19,8 +19,12 @@
 """
 
 from bzrlib.transport import (
+    get_transport,
     pathfilter,
     register_transport,
+    Server,
+    Transport,
+    unregister_transport,
     )
 
 

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2010-04-28 07:53:34 +0000
+++ bzrlib/transport/local.py	2010-03-11 04:18:33 +0000
@@ -399,18 +399,13 @@
 
     def rename(self, rel_from, rel_to):
         path_from = self._abspath(rel_from)
-        path_to = self._abspath(rel_to)
         try:
             # *don't* call bzrlib.osutils.rename, because we want to
-            # detect conflicting names on rename, and osutils.rename tries to
-            # mask cross-platform differences there; however we do update the
-            # exception to include the filenames
-            os.rename(path_from, path_to)
+            # detect errors on rename
+            os.rename(path_from, self._abspath(rel_to))
         except (IOError, OSError),e:
             # TODO: What about path_to?
-            self._translate_error(
-                osutils._add_rename_error_details(e, path_from, path_to),
-                path_from)
+            self._translate_error(e, path_from)
 
     def move(self, rel_from, rel_to):
         """Move the item at rel_from to the location at rel_to"""

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2010-04-30 11:03:59 +0000
+++ bzrlib/tree.py	2010-02-17 05:12:01 +0000
@@ -36,6 +36,7 @@
 from bzrlib.inventory import InventoryFile
 from bzrlib.inter import InterObject
 from bzrlib.osutils import fingerprint_file
+import bzrlib.revision
 from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.trace import note
 

=== modified file 'bzrlib/uncommit.py'
--- bzrlib/uncommit.py	2010-04-30 11:03:59 +0000
+++ bzrlib/uncommit.py	2009-03-23 14:59:43 +0000
@@ -18,6 +18,8 @@
 
 # TODO: make the guts of this methods on tree, branch.
 
+import os
+
 from bzrlib import (
     errors,
     revision as _mod_revision,

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2010-04-30 11:03:59 +0000
+++ bzrlib/version.py	2010-02-23 07:43:11 +0000
@@ -27,6 +27,7 @@
     osutils,
     trace,
     )
+from bzrlib.branch import Branch
 
 
 def show_version(show_config=True, show_copyright=True, to_file=None):

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2010-04-30 11:03:59 +0000
+++ bzrlib/versionedfile.py	2010-02-17 17:11:16 +0000
@@ -45,6 +45,7 @@
 from bzrlib.graph import DictParentsProvider, Graph, StackedParentsProvider
 from bzrlib.transport.memory import MemoryTransport
 """)
+from bzrlib.inter import InterObject
 from bzrlib.registry import Registry
 from bzrlib.symbol_versioning import *
 from bzrlib.textmerge import TextMerge

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2010-04-30 11:03:59 +0000
+++ bzrlib/weave.py	2009-06-10 03:56:49 +0000
@@ -69,6 +69,8 @@
 from copy import copy
 from cStringIO import StringIO
 import os
+import time
+import warnings
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
@@ -77,11 +79,14 @@
 from bzrlib import (
     errors,
     osutils,
+    progress,
     )
 from bzrlib.errors import (WeaveError, WeaveFormatError, WeaveParentMismatch,
         RevisionAlreadyPresent,
         RevisionNotPresent,
         UnavailableRepresentation,
+        WeaveRevisionAlreadyPresent,
+        WeaveRevisionNotPresent,
         )
 from bzrlib.osutils import dirname, sha, sha_strings, split_lines
 import bzrlib.patiencediff

=== modified file 'bzrlib/win32utils.py'
--- bzrlib/win32utils.py	2010-04-30 11:03:59 +0000
+++ bzrlib/win32utils.py	2010-02-23 07:43:11 +0000
@@ -21,6 +21,7 @@
 
 import glob
 import os
+import re
 import struct
 import sys
 

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-04-30 11:35:43 +0000
+++ bzrlib/workingtree.py	2010-04-27 04:30:01 +0000
@@ -95,6 +95,7 @@
 from bzrlib.filters import filtered_input_file
 from bzrlib.trace import mutter, note
 from bzrlib.transport.local import LocalTransport
+from bzrlib.progress import ProgressPhase
 from bzrlib.revision import CURRENT_REVISION
 from bzrlib.rio import RioReader, rio_file, Stanza
 from bzrlib.symbol_versioning import (

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2010-04-30 11:03:59 +0000
+++ bzrlib/workingtree_4.py	2010-03-10 09:31:25 +0000
@@ -53,6 +53,7 @@
 from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.filters import filtered_input_file, internal_size_sha_file_byname
 from bzrlib.inventory import Inventory, ROOT_ID, entry_factory
+import bzrlib.mutabletree
 from bzrlib.mutabletree import needs_tree_write_lock
 from bzrlib.osutils import (
     file_kind,

=== modified file 'bzrlib/xml4.py'
--- bzrlib/xml4.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml4.py	2010-02-17 17:11:16 +0000
@@ -16,11 +16,12 @@
 
 from bzrlib.xml_serializer import (
     Element,
+    ElementTree,
     SubElement,
     XMLSerializer,
     escape_invalid_chars,
     )
-from bzrlib.inventory import ROOT_ID, Inventory
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 import bzrlib.inventory as inventory
 from bzrlib.revision import Revision
 from bzrlib.errors import BzrError

=== modified file 'bzrlib/xml8.py'
--- bzrlib/xml8.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml8.py	2010-02-17 17:11:16 +0000
@@ -30,7 +30,7 @@
     XMLSerializer,
     escape_invalid_chars,
     )
-from bzrlib.inventory import InventoryEntry
+from bzrlib.inventory import ROOT_ID, Inventory, InventoryEntry
 from bzrlib.revision import Revision
 from bzrlib.errors import BzrError
 

=== modified file 'bzrlib/xml_serializer.py'
--- bzrlib/xml_serializer.py	2010-04-30 11:03:59 +0000
+++ bzrlib/xml_serializer.py	2010-02-17 17:11:16 +0000
@@ -23,7 +23,7 @@
 # ElementTree bits
 
 from bzrlib.serializer import Serializer
-from bzrlib.trace import mutter
+from bzrlib.trace import mutter, warning
 
 try:
     try:

=== modified file 'doc/en/Makefile'
--- doc/en/Makefile	2010-03-25 10:09:32 +0000
+++ doc/en/Makefile	2009-09-08 12:33:30 +0000
@@ -11,22 +11,6 @@
 PAPEROPT_letter = -D latex_paper_size=letter
 ALLSPHINXOPTS   = -d _build/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
 
-# Note that this assumes name of the output dir is same as name of the rule.
-define make_output_dirs
-# Create output directory (only needed for sphinx < 0.5)
-[ -d _build ] || mkdir _build
-[ -d "_build/$@" ] || mkdir "_build/$@"
-# Workaround for a bug in sphinx < 0.5 where it tries to delete
-# nonexistent static dirs and does not catch the exception.  This was
-# fixed in svn+ssh://pythondev@svn.python.org/doctools/branches/0.4.x
-# at r65551 and merged as 280b62246342 in hg branch released as 0.5.
-[ -d "_build/$@/_static" ] || mkdir "_build/$@/_static"
-for fn in _static/*; do \
-    [ ! -d "$$fn" ] && continue; \
-    [ -d "_build/$@/$$fn" ] || mkdir "_build/$@/$$fn"; \
-done
-endef
-
 .PHONY: help clean html dirhtml pickle json htmlhelp qthelp latex changes linkcheck doctest
 
 help:
@@ -46,38 +30,32 @@
 	-rm -rf _build/*
 
 html:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) _build/html
 	@echo
 	@echo "Build finished. The HTML pages are in _build/html."
 
 dirhtml:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) _build/dirhtml
 	@echo
 	@echo "Build finished. The HTML pages are in _build/dirhtml."
 
 pickle:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) _build/pickle
 	@echo
 	@echo "Build finished; now you can process the pickle files."
 
 json:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) _build/json
 	@echo
 	@echo "Build finished; now you can process the JSON files."
 
 htmlhelp:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) _build/htmlhelp
 	@echo
 	@echo "Build finished; now you can run HTML Help Workshop with the" \
 	      ".hhp project file in _build/htmlhelp."
 
 qthelp:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) _build/qthelp
 	@echo
 	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
@@ -87,7 +65,6 @@
 	@echo "# assistant -collectionFile _build/qthelp/Bazaar.qhc"
 
 latex:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) _build/latex
 	@echo
 	@echo "Build finished; the LaTeX files are in _build/latex."
@@ -95,20 +72,17 @@
 	      "run these through (pdf)latex."
 
 changes:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) _build/changes
 	@echo
 	@echo "The overview file is in _build/changes."
 
 linkcheck:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) _build/linkcheck
 	@echo
 	@echo "Link check complete; look for any errors in the above output " \
 	      "or in _build/linkcheck/output.txt."
 
 doctest:
-	$(make_output_dirs)
 	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) _build/doctest
 	@echo "Testing of doctests in the sources finished, look at the " \
 	      "results in _build/doctest/output.txt."

=== modified file 'doc/en/user-guide/hooks.txt'
--- doc/en/user-guide/hooks.txt	2010-04-22 07:35:06 +0000
+++ doc/en/user-guide/hooks.txt	2010-04-21 07:52:31 +0000
@@ -77,19 +77,32 @@
   Always conflicts if both branches have changed the file.
   """
   
-  from bzrlib.merge import PerFileMerger, Merger
+  from bzrlib.merge import AbstractPerFileMerger, Merger
   
   def merge_xml_files_hook(merger):
       """Hook to merge *.xml files"""
       return MergeXMLFiles(merger)
   
-  class AlwaysConflictXMLMerger(PerFileMerger):
-  
-      def file_matches(self, params):
-          filename = self.get_filename(params, self.merger.this_tree)
-          return filename.endswith('.xml')
-  
-      def merge_matching(self, params):
+  class MergeXMLFiles(AbstractPerFileMerger):
+  
+      def filename_matches(self, params):
+          inventory = self.merger.this_tree.inventory
+          filename = inventory[params.file_id].name
+          if filename.endswith('.xml'):
+              return filename
+  
+      def merge_contents(self, params):
+          """Merge the contents of a single file."""
+          # First, check whether this custom merge logic should be used. We
+          # expect most files should not be merged by this handler.
+          if (
+              # OTHER is a straight winner, rely on default merge.
+              params.winner == 'other' or
+              # THIS and OTHER aren't both files.
+              not params.is_file_merge() or
+              # The filename doesn't match *.xml
+              not self.filename_matches(params)):
+              return 'not_applicable', None
           return 'conflicted', params.this_lines
   
   Merger.hooks.install_named_hook(

